//
//  NSTimer+Closure.swift
//  Clock
//
//  Created by Holger Hinzberg on 16.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import Foundation

typealias TimerClosure = () -> ()

extension NSTimer
{
    // Eine Container-Klasse um einen Closure aufzunehmen
    class TimerClosureContainer
    {
        var Closure:TimerClosure?
        
        init( timerBlock:TimerClosure?)
        {
            self.Closure = timerBlock;
        }
    }
    
    class func scheduledTimerWithTimeInterval(ti: NSTimeInterval,
        repeats yesOrNo: Bool,closure: TimerClosure?) -> NSTimer
    {
        // Closure in einem Objekt "verpacken"
        let info = TimerClosureContainer(timerBlock: closure)
        // Timer initialisieren und das Objekt als userInfo übergeben
        return NSTimer.scheduledTimerWithTimeInterval(1.0, target: self, selector: "clockTick:" , userInfo: info, repeats: yesOrNo )
    }
    
    class func clockTick(timer:NSTimer)
    {
        if let container = timer.userInfo as? TimerClosureContainer
        {
            container.Closure?()
        }
    }
}